local L,SN,ST,EJSN,EJST = DXE.L,DXE.SN,DXE.ST,DXE.EJSN,DXE.EJST

local EJName = EJ_GetEncounterInfo(959)
do
	local data = {
		version = 3,
		key = "Blackhand",
		zone = L.zone["Blackrock Foundry"],
		category = L.zone["Blackrock Foundry"],
		--name = L.npc_BlackrockFoundry["Blackhand"],
		name = EJName,
		icon = "INTERFACE\\ENCOUNTERJOURNAL\\UI-EJ-BOSS-Warlord Blackhand.BLP:35:35",
		triggers = {
			scan = {77325}, 
			encounterid = {1704},
			ejid = {959},
		},
		onactivate = {
			tracing = {77325},
			tracerstart = true,
			combatstop = true,
			unittracing = {"boss1"},
			defeat = 77325,
		},
		windows = {
			proxwindow = true,
		},
		enrage = {
			--timelfr = 600,
			--timeflex = 600,
			--timeheroic = 600,
			--timemythic = 600,
		},
		raidicons = {
			MarkedforDeathmark = {
				varname = SN[156096],
				type = "MULTIFRIENDLY",
				persist = 120,
				unit = "#5#",
				icon = 1,
				total = 2,
				reset = 10,
				desc = 156096,
				icon2 = ST[156096],
			},				
		},		
		timers = {
			timerMarkedforDeath = {
				{
					"message","mMarkedforDeath",
				},
			},
			timerAttachSlagBombs = {
				{
					"message","mAttachSlagBombs",
				},
			},			
		},	
		announces = { 
			MarkedforDeathsay = {
				varname = format(L.alert["%s %s %s!"],SN[156096],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[156096],L.alert["on"],L.alert["Me"]),
				desc = 156096,
				icon = ST[156096],
				--flashcolor = "RED",
				--flashscreen = true,
			},
			AttachSlagBombssay = {
				varname = format(L.alert["%s %s %s!"],SN[157000],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[157000],L.alert["on"],L.alert["Me"]),
				desc = 157000,
				icon = ST[157000],
			},	
			Fixatesay = {
				varname = format(L.alert["%s %s %s!"],SN[156653],L.alert["on"],L.alert["Me"]),
				type = "SAY",
				msg = format(L.alert["%s %s %s!"],SN[156653],L.alert["on"],L.alert["Me"]),
				desc = 156653,
				icon = ST[156653],
			},			
		},			
		userdata = {
			MarkedforDeathunits = {type = "container", wipein = 3},
			AttachSlagBombsunits = {type = "container", wipein = 3},
			phase = 1,
			SlagEruption = 0,
			smashCount = 0,
		},		
		messages = {
			mMarkedforDeath = {
				varname = format(L.alert["%s %s %s"],SN[156096],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|MarkedforDeathunits&"],SN[156096],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 156096,
				icon = ST[156096],
			},
			mAttachSlagBombs = {
				varname = format(L.alert["%s %s %s"],SN[157000],L.alert["on"],L.alert["player"]),
				type = "message",
				text = format(L.alert["%s %s &list|AttachSlagBombsunits&"],SN[157000],L.alert["on"]),
				color1 = "RED",
				sound = "ALERT13",
				desc = 157000,
				icon = ST[157000],
			},	
			mSiegemaker = {
				varname = format(L.alert["%s!"],SN[156667]),
				type = "message",
				text = format(L.alert["%s!"],SN[156667]),
				color1 = "TAN",
				sound = "ALERT13",
				desc = 156667,
				icon = ST[156667],
			},
			mDemolition = {
				varname = format(L.alert["%s!"],SN[156425]),
				type = "message",
				text = format(L.alert["%s!"],SN[156425]),
				color1 = "ORANGE",
				sound = "ALERT13",
				desc = 156425,
				icon = ST[156425],
			},			
		},
		onstart = {
			{
				"alert",{"ThrowSlagBombsCD", time = 2},
				"alert",{"DemolitionCD", time = 2},
				"alert",{"ShatteringSmashCD", time = 2},
				"alert",{"MarkedforDeathCD", time = 2},
			},
		},
		alerts = {
			DemolitionCD = {
				varname = format(L.alert["Next %s"],SN[156425]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[156425]),
				time = 45,
				time2 = 15,
				color1 = "NEWBLUE",
				icon = ST[156425],
				desc = 156425,
			},
			MarkedforDeathCD = {
				varname = format(L.alert["Next %s"],SN[156096]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN[156096]),
				time = 15.5,
				time2 = 36,
				time3 = 25,
				time4 = 20.5,
				time5 = 27,
				color1 = "NEWBLUE",
				icon = ST[156096],
				desc = 156096,
			},
			ThrowSlagBombsCD = {
				varname = format(L.alert["%s Cooldown"],SN[156030]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156030]),
				time = 25,
				time2 = 6,
				time3 = 11,
				color1 = "NEWBLUE",
				icon = ST[156030],
				desc = 156030,
			},
			ShatteringSmashCD = {
				varname = format(L.alert["%s Cooldown"],SN[155992]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[155992]),
				time = 45.5,
				time2 = 21,
				time3 = 30,
				time4 = 25,
				time5 = 26,
				color1 = "NEWBLUE",
				icon = ST[155992],
				desc = 155992,
			},
			SiegemakerCD = {
				varname = format(L.alert["Next %s"],SN["ej9571"]),
				type = "dropdown",
				text = format(L.alert["Next %s"],SN["ej9571"]),
				time = 50,
				time2 = 15,
				color1 = "NEWBLUE",
				icon = ST[156667],
				ability = 9571,
			},
			SlagEruptionCD = {
				varname = format(L.alert["(2) %s Cooldown"],SN[156928]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[156928]),
				time = 32.5,
				time2 = 31.5,
				color1 = "NEWBLUE",
				icon = ST[156928],
				desc = 156928,
				counter = true,
			},
			AttachSlagBombsCD = {
				varname = format(L.alert["%s Cooldown"],SN[157000]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[157000]),
				time = 26,
				time2 = 11,
				color1 = "NEWBLUE",
				icon = ST[157000],
				desc = 157000,
			},				
			-- Warning
			wCauterizingBolt = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155992]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[155992]),
				time = 2,
				color1 = "RED",
				icon = ST[155992],
				sound = "ALERT11",
				desc = 155992,
			},
			wSlagEruption = {
				varname = format(L.alert["%s %s (2)"],L.alert["Incoming"],SN[156928]),
				type = "simple",
				text = format(L.alert["%s %s (<SlagEruption>)"],L.alert["Incoming"],SN[156928]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[156928],
				sound = "ALERT13",
				desc = 156928,
			},	
			wMassiveShatteringSmash = {
				varname = format(L.alert["%s %s!"],L.alert["Incoming"],SN[158054]),
				type = "simple",
				text = format(L.alert["%s %s!"],L.alert["Incoming"],SN[158054]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[158054],
				sound = "ALERT13",
				desc = 158054,
			},	
			Phase2 = {
				varname = format(L.alert["Phase 2"]),
				type = "simple",
				text = format(L.alert["Phase 2"]),
				time = 2,
				color1 = "YELLOW",
				icon = ST[161347],
				sound = "ALERT13",
			},
			Phase3 = {
				varname = format(L.alert["Phase 3"]),
				type = "simple",
				text = format(L.alert["Phase 3"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[161348],
				sound = "ALERT13",
			},			
			-- Inform
			iShatteringSmash = {
				varname = format(L.alert["%s (2)!"],SN[155992]),
				type = "inform",
				text = format(L.alert["%s (<smashCount>)"],SN[155992]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[155992],
				sound = "ALERT13",
				desc = 155992,
				extank = true,
				exhealer = true,
			},			
			iMarkedforDeath = {
				varname = format(L.alert["%s %s %s!"],SN[156096],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[156096],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[156096],
				sound = "ALERT10",
				desc = 156096,
				flashscreen = true,
			},
			iFixate = {
				varname = format(L.alert["%s %s %s!"],SN[156653],L.alert["on"],L.alert["YOU"]),
				type = "inform",
				text = format(L.alert["%s %s %s!"],SN[156653],L.alert["on"],L.alert["YOU"]),
				time = 2,
				color1 = "RED",
				icon = ST[156653],
				sound = "ALERT12",
				desc = 156653,
				flashscreen = true,
			},			
			iThrowSlagBombs = {
				varname = format(L.alert["%s, %s!"],SN[156030],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s, %s!"],SN[156030],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[156030],
				sound = "ALERT12",
				desc = 156030,
				flashscreen = true,
			},				
			iMoltenSlag = {
				varname = format(L.alert["%s %s, %s!"],SN[156401],L.alert["under you"],L.alert["MOVE AWAY"]),
				type = "inform",
				text = format(L.alert["%s %s, %s!"],SN[156401],L.alert["under you"],L.alert["MOVE AWAY"]),
				time = 2,
				color1 = "ORANGE",
				icon = ST[156401],
				sound = "ALERT12",
				desc = 156401,
				flashscreen = true,
				throttle = 2,
			},	
			iSiegemaker = {
				varname = format(L.alert["%s %s!"],SN["ej9571"],L.alert["SWITCH TARGET"]),
				type = "inform",
				text = format(L.alert["%s %s!"],SN["ej9571"],L.alert["SWITCH TARGET"]),
				time = 2,
				color1 = "ORANGE",
				sound = "ALERT11",                
				icon = EJST[9571],
				ability = 9571,
				exhealer = true,
				extank = true,
				throttle = 3,
			},					
			-- Casts
			ImpalingThrowCast = {
				varname = format(L.alert["%s Active"],SN[156111]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[156111]),
				time = 5,
				color1 = "RED",
				icon = ST[156111],
				desc = 156111,
			},			
			AttachSlagBombsCast = {
				varname = format(L.alert["%s Active"],SN[157000]),
				type = "centerpopup",
				text = format(L.alert["%s Active"],SN[157000]),
				time = 5,
				color1 = "RED",
				icon = ST[157000],
				desc = 157000,
			},
		},
		events = {
			-- ShatteringSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {155992,159142},
				execute = {
					{
						"set",{smashCount = "INCR|1"},
					},
					{
						"expect",{"<phase>","==","1"},
						"alert","ShatteringSmashCD",
						"invoke",{
							{
								"expect",{"&istank&","==","true"},
								"alert","wShatteringSmash",
							},
						},
					},
					{
						"expect",{"<phase>","~=","1"},
						"alert",{"ShatteringSmashCD", time = 3},
						"alert","iShatteringSmash", -- melees
					},			
				},
			},	
			-- SlagEruption
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {156928},
				execute = {
					{
						"set",{SlagEruption = "INCR|1"},
						"batchalert",{"SlagEruptionCD","wSlagEruption"},
					},			
				},
			},
			-- MassiveShatteringSmash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid = {158054},
				execute = {
					{
						"set",{smashCount = "INCR|1"},
						"alert","wMassiveShatteringSmash",
						"alert",{"ShatteringSmashCD", time = 4},
					},			
				},
			},	
			-- MarkedforDeath
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156096},
				execute = {
					{
						"insert",{"MarkedforDeathunits","#5#"},
						"canceltimer","timerMarkedforDeath",
						"scheduletimer",{"timerMarkedforDeath",0.5},	
						--"alert","MarkedforDeathCD",
						"alert","ImpalingThrowCast",
						"raidicon","MarkedforDeathmark",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","MarkedforDeathsay",
						"alert","iMarkedforDeath",
					},
					{
						"expect",{"<phase>","~=","3"},
						"alert","MarkedforDeathCD",
					},
					{
						"expect",{"<phase>","==","3"},
						"alert",{"MarkedforDeathCD", time = 4},
					},					
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {156096},
				dstisplayerunit = true,
				execute = {
					{
						"quash","ImpalingThrowCast",
						"removeraidicon","#5#",
					},	
				},
			},
			-- AttachSlagBombs
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {157000, 159179},
				execute = {
					{
						"insert",{"AttachSlagBombsunits","#5#"},
						"canceltimer","timerAttachSlagBombs",
						"scheduletimer",{"timerAttachSlagBombs",0.5},	
						"alert","AttachSlagBombsCD",
					},	
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","AttachSlagBombssay",
						"alert","AttachSlagBombsCast",
						"alert","iAttachSlagBombs",
						"openwindow",{"10"},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {157000, 159179},
				dstisplayerunit = true,
				execute = {
					{
						"quash","AttachSlagBombsCast",
						"closewindow",
					},	
				},
			},
			-- Siegemaker
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156667},
				execute = {
					{
						"message","mSiegemaker",
						"alert","SiegemakerCD",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellid = {156667},
				execute = {
					{
						"alert","iSiegemaker",
					},	
				},
			},
			-- MoltenSlag
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156401},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMoltenSlag",
					},					
				},
			},	
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_DAMAGE",
				spellid = {156401},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMoltenSlag",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_PERIODIC_MISSED",
				spellid = {156401},
				dstisplayerunit = true,
				execute = {
					{
						"alert","iMoltenSlag",
					},
				},
			},
			-- Fixate
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellid = {156653},
				execute = {
					{
						"message","mFixate",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","Fixatesay",
						"alert","iFixate",
					},					
				},
			},			
			--
			{
				type = "event",
				event = "UNIT_SPELLCAST_SUCCEEDED", 
				execute = {
					{
						"expect",{"#1#","==","boss1"},
						"invoke",{
							{
								"expect",{"#5#","==","156031"}, -- ThrowSlagBombs
								"alert","ThrowSlagBombsCD",
								"alert","iThrowSlagBombs",
							},
							{
								"expect",{"#5#","==","156998"}, -- ThrowSlagBombs
								"alert","ThrowSlagBombsCD",
								"alert","iThrowSlagBombs",
							},	
							{
								"expect",{"#5#","==","156425"}, -- Demolition
								"alert","DemolitionCD",
								"message","mDemolition",
							},
							{
								"expect",{"#5#","==","161347"}, -- Phase 2 Trigger
								"set",{phase = 2},
								"set",{smashCount = 0},
								"quash","DemolitionCD",
								"alert",{"ThrowSlagBombsCD", time = 3},
								"alert",{"ShatteringSmashCD", time = 2},
								"alert",{"SiegemakerCD", time = 2},
								"alert",{"MarkedforDeathCD", time = 3},
								"alert","Phase2",
								"invoke",{
									{
										"expect",{"&ismelee&","==","false"},
										"openwindow",{"6"},
									},
								},
							},	
							{
								"expect",{"#5#","==","161348"}, -- Phase 3 Trigger
								"set",{phase = 3},
								"set",{smashCount = 0},
								"batchquash",{"SiegemakerCD","ThrowSlagBombsCD","ShatteringSmashCD"},
								"alert",{"AttachSlagBombsCD", time = 2},
								"alert",{"ShatteringSmashCD", time = 5},
								"alert",{"MarkedforDeathCD", time = 5},
								"alert",{"SlagEruptionCD", time = 2},
								"alert","Phase3",
								"closewindow",
							},									
						},
					},
				},
			},				
		},
	}

	DXE:RegisterEncounter(data)
end